// Borland C++ Builder
// Copyright (c) 1995, 2005 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Logerror.pas' rev: 10.00

#ifndef LogerrorHPP
#define LogerrorHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Logbase.hpp>	// Pascal unit
#include <Smmapfile.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Logerror
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TSMLAOption { laShowSendEMail, laShowSupportLink, laShowSourceLine };
#pragma option pop

typedef Set<TSMLAOption, laShowSendEMail, laShowSourceLine>  TSMLAOptions;

#pragma option push -b-
enum TSMLErrorDialog { edNone, edStandard, edExtended };
#pragma option pop

#pragma option push -b-
enum TSMLFormat { lfDate, lfTime, lfPhysAddress, lfExceptionClassName, lfMessage, lfSeparator, lfSourceLine, lfApplication, lfActiveControl, lfComputerInfo, lfOSInfo, lfCPUInfo, lfMemoryInfo, lfVideoCard };
#pragma option pop

typedef Set<TSMLFormat, lfDate, lfVideoCard>  TSMLFormats;

#pragma option push -b-
enum TSMExceptionStandard { efAbort, efOutOfMemory, efInOutError, efIntError, efDivByZero, efRangeError, efIntOverflow, efMathError, efInvalidOp, efZeroDivide, efOverflow, efUnderflow, efInvalidPointer, efInvalidCast, efConvertError, efAccessViolation, efPrivilege, efStackOverflow, efControlC, efVariantError, efPropReadOnly, efPropWriteOnly, efExternalException, efAssertionFailed, efAbstractError, efIntfCastError, efInvalidContainer, efInvalidInsert, efPackageError, efWin32Error };
#pragma option pop

typedef Set<TSMExceptionStandard, efAbort, efWin32Error>  TSMExceptionStandards;

#pragma option push -b-
enum TSMExceptionClass { efStreamError, efFCreateError, efFOpenError, efFilerError, efReadError, efWriteError, efClassNotFound, efMethodNotFound, efInvalidImage, efResNotFound, efListError, efBitsError, efStringListError, efComponentError, efParserError, efOutOfResources, efInvalidOperation, efThread };
#pragma option pop

typedef Set<TSMExceptionClass, efStreamError, efThread>  TSMExceptionClasses;

#pragma option push -b-
enum TSMExceptionGraphic { efInvalidGraphic, efInvalidGraphicOperation };
#pragma option pop

typedef Set<TSMExceptionGraphic, efInvalidGraphic, efInvalidGraphicOperation>  TSMExceptionGraphics;

typedef void __fastcall (__closure *TSMLSaveExceptionEvent)(System::TObject* Sender, Sysutils::Exception* E, AnsiString &LogText, bool &Accept);

class DELPHICLASS TSMExceptionLog;
class PASCALIMPLEMENTATION TSMExceptionLog : public Logbase::TSMLogBase 
{
	typedef Logbase::TSMLogBase inherited;
	
private:
	bool InternalProcessing;
	Forms::TExceptionEvent FoldOnException;
	Forms::TExceptionEvent FOnException;
	TSMLSaveExceptionEvent FOnSaveException;
	TSMLErrorDialog FErrorDialog;
	TSMExceptionStandards FFilterStandard;
	TSMExceptionClasses FFilterClasses;
	TSMExceptionGraphics FFilterGraphics;
	TSMLFormats FFormats;
	TSMLAOptions FOptions;
	Smmapfile::TSMMapFile* FMapFile;
	void __fastcall ActiveWeb(System::TObject* Sender);
	void __fastcall ActivateMail(System::TObject* Sender, bool IncludeScreenshot);
	
protected:
	void __fastcall DoException(System::TObject* Sender, Sysutils::Exception* E);
	
public:
	__fastcall virtual TSMExceptionLog(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMExceptionLog(void);
	AnsiString __fastcall GetFormattedSource();
	AnsiString __fastcall GetApplicationDetails();
	AnsiString __fastcall GetActiveControlDetails();
	AnsiString __fastcall GetComputerInfo();
	AnsiString __fastcall GetMemoryInfo();
	AnsiString __fastcall GetOSInfo();
	AnsiString __fastcall GetCPUInfo(bool IncludeSpeed);
	AnsiString __fastcall GetVideoCardInfo();
	__property Smmapfile::TSMMapFile* MapFile = {read=FMapFile, write=FMapFile};
	
__published:
	__property TSMLErrorDialog ErrorDialog = {read=FErrorDialog, write=FErrorDialog, default=2};
	__property TSMExceptionStandards FilterStandard = {read=FFilterStandard, write=FFilterStandard, default=1073741823};
	__property TSMExceptionClasses FilterClasses = {read=FFilterClasses, write=FFilterClasses, default=262143};
	__property TSMExceptionGraphics FilterGraphics = {read=FFilterGraphics, write=FFilterGraphics, default=3};
	__property TSMLFormats Formats = {read=FFormats, write=FFormats, default=951};
	__property TSMLAOptions Options = {read=FOptions, write=FOptions, default=3};
	__property Forms::TExceptionEvent OnException = {read=FOnException, write=FOnException};
	__property TSMLSaveExceptionEvent OnSaveException = {read=FOnSaveException, write=FOnSaveException};
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Logerror */
using namespace Logerror;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Logerror
